// Media control for Silverlight and HTML5 Canvas (v1.1.1)

var EV_SL_MediaEnded, EV_SL_MediaOpened

function SL_MediaOpened(sender, args) {
  if (EV_SL_MediaOpened && EV_SL_MediaOpened(sender, args))
    return
}

function SL_MediaEnded(sender, args) {
  if (EV_SL_MediaEnded && EV_SL_MediaEnded(sender, args))
    return

  sender.Stop()
  sender.Play()
}

var SL_MC_timerID
var SL_MC_timeout = 10*1000
var EV_SL_Media_MouseEnter

function SL_Media_MouseEnter(sender, args) {
  SL_MC_MouseEnter()

  var mc = SL_root.FindName("C_media_control")
  if (mc.Visibility == "Visible")
    return
  if (EV_SL_Media_MouseEnter && EV_SL_Media_MouseEnter(sender, args))
    return

  if (self.EQP_use_HTML5_video && (!self.EQP_video_options || !EQP_video_options.use_overlay_video)) {
    if (!EQP_gallery_obj_active.imgs[0].video_loaded)
      return

    SL_MC_video_obj = EQP_gallery_obj_active.imgs[0].img_obj_v
  }
  else
    SL_MC_video_obj = sender

  SL_MC_Update()

  mc.Visibility = "Visible"

  SL_MC_timerID = setTimeout('SL_MC_timerID=null; SL_root.FindName("C_media_control").Visibility = "Collapsed";', SL_MC_timeout)
}

var SL_tooltip_msg_custom

function SL_MC_MouseEnter(sender, args) {
  if (SL_MC_timerID) {
    clearTimeout(SL_MC_timerID)
    SL_MC_timerID = null
  }

  if (!sender)
    return

  var name = sender.Name
  if (!/^MC_(.+)$/.test(name))
    return

  name = RegExp.$1

  var options = (SL_MC_video_obj && self.EQP_use_HTML5_video) ? SL_MC_video_obj._EQP_obj.EQP_video_options : null

switch (name) {
  case "play":
    SL_tooltip_msg_custom = 'Play / Pause'
    break
  case "stop":
    SL_tooltip_msg_custom = 'Stop' + (((use_WMP && WMP.in_use) || (!EQP_dragdrop_target || !EQP_dragdrop_target.is_video || !EQP_dragdrop_target.img_obj_i)) ? '' : ' (click again to hide video)')
    break
  case "forward":
    SL_tooltip_msg_custom = 'Seek forward'//(options && options.BPM_mode) ? 'BPM sync+' : 'Seek forward'
    break
  case "backward":
    SL_tooltip_msg_custom = 'Seek backward'//(options && options.BPM_mode) ? 'BPM sync-' : 'Seek backward'
    break
  case "sound":
    SL_tooltip_msg_custom = ((options && options.BPM_mode && options.beat_reference && !SL_MC_video_obj.paused) || (use_WMP && WMP.in_use && WMP.audio_child_list)) ? 'Click on a beat to sync BPM.' : 'Mute / Unmute'
    break
}

  if (SL_tooltip_msg_custom) {
    if (use_HTML5)
      document.getElementById("MC_" + name).title = SL_tooltip_msg_custom
    else
      SL_Tooltip_Show(SL_tooltip_msg_custom)
  }
}


// Media control

function SL_MC_MouseLeave() {
  SL_MC_MouseEnter()
  SL_MC_timerID = setTimeout('SL_MC_timerID=null; SL_root.FindName("C_media_control").Visibility = "Collapsed";', SL_MC_timeout)
}

var SL_MC_video_obj

function SL_MC_Update() {
  if (use_WMP && WMP.in_use) {
    if (!use_HTML5)
      SL_root.FindName("MC_play").Text  = (WMP.player.playState == 3) ? ";" : "4"
    SL_root.FindName("MC_sound").Text = (WMP.player.settings.mute) ? ((use_HTML5)?"\ud83d\udd07":"U") : ((use_HTML5)?"\ud83d\udd0a":"V")
  }
  else if (self.EQP_use_HTML5_video && (!self.EQP_video_options || !EQP_video_options.use_overlay_video)) {
    if (!use_HTML5)
      SL_root.FindName("MC_play").Text  = (!SL_MC_video_obj.paused) ? ";" : "4"
    SL_root.FindName("MC_sound").Text = (SL_MC_video_obj.muted) ? ((use_HTML5)?"\ud83d\udd07":"U") : ((use_HTML5)?"\ud83d\udd0a":"V")
  }
  else {
    if (!use_HTML5)
      SL_root.FindName("MC_play").Text  = (SL_MC_video_obj.CurrentState == "Playing") ? ";" : "4"
    SL_root.FindName("MC_sound").Text = (SL_MC_video_obj.IsMuted) ? ((use_HTML5)?"\ud83d\udd07":"U") : ((use_HTML5)?"\ud83d\udd0a":"V")
  }
}

function SL_MC_Play() {
  var vo = self.EQP_video_options

//play=52,4, pause=59,;
  if (use_WMP && WMP.in_use)
    WMP.play()
  else if (self.EQP_use_HTML5_video && (!vo || !vo.use_overlay_video)) {
    if (SL_MC_video_obj)
      SL_MC_video_obj.poster_mode = false

    var ao = (vo && vo.BPM_mode) ? vo.audio_obj : null
    if (ao && ao.is_linked)
      ao.linked_play()
    else {
      // for Winamp, just in case SL_MC_Play is called before SL_MC_video_obj is assigned.
      if (!SL_MC_video_obj)
        SL_MC_video_obj = EQP_gallery_obj_active.imgs[0].img_obj_v

      if (SL_MC_video_obj.paused) {
        if (vo)
          vo.poster_frame_ignored = true

        SL_MC_video_obj.play()
        if (ao) {
          ao.play()

          if (ao.is_winamp && vo.BPM_mode && vo.beat_reference) {
var time_reference = (ao.beat_reference - ao.currentTime) * ao.BPM/vo.BPM + SL_MC_video_obj.currentTime
setTimeout(function () {EQP_SyncBPM_Auto(SL_MC_video_obj, vo, time_reference)}, 1000)
          }
        }
      }
      else {
        if (vo)
          vo.poster_frame_ignored = false

        SL_MC_video_obj.pause()
        if (ao)
          ao.pause()
      }
    }
  }
  else {
    if (SL_MC_video_obj.CurrentState == "Playing")
      SL_MC_video_obj.Pause()
    else
      SL_MC_video_obj.Play()
  }

  setTimeout('SL_MC_Update()', 0)
}

function SL_MC_Stop() {
  var vo = self.EQP_video_options

  if (use_WMP && WMP.in_use)
    WMP.stop()
  else if (self.EQP_use_HTML5_video && (!vo || !vo.use_overlay_video)) {
    var ao = (vo && vo.BPM_mode) ? vo.audio_obj : null
    if (ao && ao.is_linked)
      ao.linked_stop()
    else {
      // for Winamp, just in case SL_MC_Play is called before SL_MC_video_obj is assigned.
      if (!SL_MC_video_obj)
        SL_MC_video_obj = EQP_gallery_obj_active.imgs[0].img_obj_v

      if (ao && ao.is_winamp) {
        SL_MC_Play()
        return
      }

      if (SL_MC_video_obj)
        SL_MC_video_obj.pause()

      var vo = vo
      if (vo) {
        vo.poster_frame_ignored = false

        if ((vo.poster_frame >= 0) && !vo.BPM_mode) {
          SL_MC_video_obj.poster_mode = true
          SL_MC_video_obj.currentTime = vo.poster_frame
        }
        else if (vo.SEQ_mode && vo.SEQ_gallery)
          SL_MC_Seek(-1, true)
        else
          SL_MC_video_obj.currentTime = 0

        if (vo.BPM_mode) {
          ao.pause()
          vo.audio_onended()
        }
      }
    }
  }
  else {
    SL_MC_video_obj.Stop()

    if (SL_MC_video_obj.CurrentState == "Stopped") {
      EQP_Hide_Video()
      return
    }
  }

  setTimeout('SL_MC_Update()', 0)
}

function SL_MC_Forward() {
  SL_MC_Seek(1, true)
}

function SL_MC_Backward() {
  SL_MC_Seek(-1, true)
}

function SL_MC_Seek(mod, forced_seek) {
  if (use_WMP && WMP.in_use) {
    try {
      WMP.player.controls.currentPosition += 30 * mod
    }
    catch (err) {
      DEBUG_show('(media seek failed)', 2)
    }
    return
  }

  if (self.EQP_use_HTML5_video && (!self.EQP_video_options || !EQP_video_options.use_overlay_video)) {
    // for Winamp, just in case SL_MC_Play is called before SL_MC_video_obj is assigned.
    if (!SL_MC_video_obj)
      SL_MC_video_obj = EQP_gallery_obj_active.imgs[0].img_obj_v

    try {
      if (SL_MC_video_obj.seeking)
        return

      SL_MC_video_obj.poster_mode = false

      var options = SL_MC_video_obj._EQP_obj.EQP_video_options
      if (options && (forced_seek || !options.BPM_mode) && options.SEQ_mode && options.SEQ_gallery && SL_MC_video_obj.muted) {
        options._gallery_change = (mod > 0)
        options._gallery_loop   = (mod < 0)
      }
      else {
if (options && options.BPM_mode) {
  if (!options.BPM_syncing) {
    if (options.BPM_syncing_timerID) {
      clearTimeout(options.BPM_syncing_timerID)
      options.BPM_syncing_timerID = null

      EQP_SyncBPM(SL_MC_video_obj, 60/options.audio_obj.BPM*mod, 'beat')
    }
    else {
      options.BPM_syncing_timerID = setTimeout(
  'SL_MC_video_obj._EQP_obj.EQP_video_options.BPM_syncing_timerID = null; '
+ 'EQP_SyncBPM(SL_MC_video_obj, ' + (mod/10) + ');'
      , 300);
    }
  }
}
else
  SL_MC_video_obj.currentTime += 30 * mod
      }
    }
    catch (err) {}
    return
  }

  if (!SL_MC_video_obj.CanSeek || (SL_MC_video_obj.CurrentState == "Stopped"))
    return

  var s = parseInt(SL_MC_video_obj.Position.Seconds) + 30 * mod
  if ((s < 0) || (s > SL_MC_video_obj.NaturalDuration.Seconds))
    return

  var m = parseInt(s/60)
  var h = parseInt(m/60)
  s = s % 60
  m = m % 60

  var p = h+':'+m+':'+s
  SL_MC_video_obj.Position = p
  DEBUG_show(p, 2)
}

function SL_MC_Sound() {
//sound=85,U, mute=86,V
  if (use_WMP && WMP.in_use)
    WMP.sound()
  else if (self.EQP_use_HTML5_video && self.EQP_video_options && EQP_video_options.BPM_mode && EQP_video_options.beat_reference && !SL_MC_video_obj.paused) {
    var ao = (self.EQP_video_options && EQP_video_options.BPM_mode) ? EQP_video_options.audio_obj : null
    if (ao && ao.is_linked)
      ao.linked_sound()
    else
      EQP_SyncBPM_Auto(SL_MC_video_obj, EQP_video_options)

    return
  }
  else if (self.EQP_use_HTML5_video && (!self.EQP_video_options || !EQP_video_options.use_overlay_video)) {
    SL_MC_video_obj.muted = !SL_MC_video_obj.muted
  }
  else {
    if (SL_MC_video_obj.IsMuted) {
      SL_MC_video_obj.IsMuted = false
      SL_MC_video_obj.Volume = 1
    }
    else
      SL_MC_video_obj.IsMuted = true
  }

  setTimeout('SL_MC_Update()', 0)
}
