// System Animator core basics (v2.7.0)

// basics
var Vista_or_above = /Windows NT [6-9]/i.test(navigator.userAgent)
var W7_or_above = /Windows NT (6\.[1-9]|[7-9])/i.test(navigator.userAgent)

// Silverlight 5 64-bit is supported only on Windows 7 and above
var ie_64bit = (/MSIE.+Win64.+x64/i.test(navigator.userAgent) && !W7_or_above)
//ie_64bit=true

var ie9, ie9_native
ie9 = ie9_native = /Trident.[5-9]/i.test(navigator.userAgent)
var ie9_mode = (document.documentMode >= 9)
var ie8_mode = (document.documentMode >= 8)

var xul_mode = /rv\:(\d+)\.\d.+Gecko/i.test(navigator.userAgent)
var xul_version = 0
if (xul_mode) {
  xul_version = parseInt(RegExp.$1)
  ie9 = ie9_mode = ie8_mode = true
  document.write(
  '<script type="text/javascript" language="javascript" src="js/SA_xul.js"></scr'+'ipt>\n'
+ '<script type="text/javascript" language="javascript" src="js/file_io.js"></scr'+'ipt>\n'
  )
}

var webkit_mode = /WebKit/i.test(navigator.userAgent)
var webkit_target_version = "0.7.5"
var webkit_version = "0"
if (webkit_mode) {
  webkit_version = process.versions['node-webkit']
  ie9 = ie9_mode = ie8_mode = true
  document.write(
  '<script type="text/javascript" language="javascript" src="js/SA_webkit.js"></scr'+'ipt>\n'
  )
}


var oShell
var Shell_OBJ, FSO_OBJ

var is_SA_child_animation
var SA_child_animation_max = 10
var SA_child_animation = []
var SA_child_animation_id


//System.Gadget.Settings
var Setting_name_list = [
  "Folder", "EventToMonitor", "EventToMonitorVF", "MonitorSensitivity", "Monitor2Sensitivity", "UpdateInterval", "Display",
  "Opacity",
  "CCPU",
  "UseAudioFFTLiveInputGain",
  "CSSTransformScale", "CSSTransformRotate", "CSSTransform3D", "CSSTransform3DBoxAnimate",
  "BDSpectrumToBeat", "BDScale", "BDOpacity", "BDBassKick"
]
var Setting_name_list_boolean = [
  "ReverseAnimation", "UseFilters", "UseMarkers", "UseImgCache", "UseFullFrameRate", "UseSilverlight", "UseSL_windowless",
  "HTALoadSpectrumAnalyser", "WallpaperAsBG", "DisableWallpaperMask", "XULTransparentBG", "XULSilverlightAuto",
  "CSSTransformFullscreen", "CSSTransformFlipH", "CSSTransformFlipV", "CSSTransformToChildAnimation", "CSSTransform3DBillboard", "CSSTransform3DDisabledForContent", "UseWebcamHeadtracking",
  "UseHTML5Canvas", "UseMatrixRain", "MatrixRainColor",
  "UseCanvasRipple", "UseCanvasFireworks", "UseSVGClock", "UseAudioFFT", "UseAudioFFTLiveInput",
  "AutoItRunAsAU3", "AutoItStayOnDesktop", "AutoItWinampMode",
  "Use32BandSpectrum", "EnableBeatDetection", "EnableMotionEffectForAnimatedPicture", "EnableMotionEffectForSEQVideo",
  "SwapRegistryCheck"
]
for (var i = 0; i < SA_child_animation_max; i++)
  Setting_name_list.push("ChildAnimation" + i)

var Settings_default = {
   Folder: "demo1"

  ,EventToMonitor: (ie9) ? "FIXED_VALUE_50" : "CPU"
  ,EventToMonitorVF: ""
  ,MonitorSensitivity: "1"
  ,Monitor2Sensitivity: "1"
  ,UpdateInterval: "10"
  ,Display: "1"

  ,Opacity: "1"

  ,ReverseAnimation: false
  ,UseFilters: false
  ,UseMarkers: false
  ,UseImgCache: false
  ,UseFullFrameRate: false

  ,CCPU: "1"

  ,UseSilverlight: true
  ,UseSL_windowless: true

  ,BDSpectrumToBeat: "0"
  ,Use32BandSpectrum: false
  ,EnableBeatDetection: true
  ,EnableMotionEffectForAnimatedPicture: false
  ,EnableMotionEffectForSEQVideo: true
  ,BDScale: "1"
  ,BDOpacity: "1"
  ,BDBassKick: "1"

  ,HTAUseGPUAcceleration: false
  ,HTALoadSpectrumAnalyser: false
  ,WallpaperAsBG: false
  ,DisableWallpaperMask: false
  ,XULTransparentBG: false
  ,XULSilverlightAuto: true

  ,CSSTransformScale: "1"
  ,CSSTransformRotate: "0"
  ,CSSTransformFullscreen: false
  ,CSSTransformFlipH: false
  ,CSSTransformFlipV: false
  ,CSSTransform3D: ""
  ,CSSTransform3DBoxAnimate: "0"
  ,CSSTransformToChildAnimation: false
  ,CSSTransform3DBillboard: false
  ,CSSTransform3DDisabledForContent: false
  ,UseWebcamHeadtracking: false

  ,UseHTML5Canvas: false
  ,UseMatrixRain: false
  ,MatrixRainColor: true

  ,UseCanvasRipple: false
  ,UseCanvasFireworks: false
  ,UseSVGClock: false
  ,UseAudioFFT: false
  ,UseAudioFFTLiveInput: false
  ,UseAudioFFTLiveInputGain: "1"

  ,AutoItRunAsAU3: false
  ,AutoItStayOnDesktop: false
  ,AutoItWinampMode: false

  ,SwapRegistryCheck: false

// obsolete
//  ,IncludeSubfolders: false
//  ,HandleOversize: "crop"
}
// END


function returnBoolean(name) {
  return ((!System.Gadget.Settings.readString(name)) ? Settings_default[name] : !Settings_default[name])
}

function toFileProtocol(url) {
  return "file:///" + url.replace(/^(\w)\:/, "$1|").replace(/\\/g, "/").replace(/ /g, "%20");
}

function toLocalPath(url) {
  return decodeURIComponent(url.replace(/^file\:\/+(\w)[\|\:]/i, "$1:").replace(/\//g, "\\").replace(/\?.+$/, ""));
}

if (!String.prototype.trim) {
  String.prototype.trim = function () {
    return this.replace(/^\s+|\s+$/g,'');
  };
}

if (!Date.now) {
  Date.now = function now() {
    return new Date().getTime();
  };
}

var HTA_use_GPU_acceleration
function getHTAUseGPUAcceleration() {
  //http://msdn.microsoft.com/en-us/library/ee330731(VS.85).aspx#gpu_rendering
  var reg_root = ['HKLM', 'HKCU']
  for (var i = 0; i < 2; i++) {
    var root = reg_root[i]
    try {
      HTA_use_GPU_acceleration = oShell.RegRead(root + '\\SOFTWARE\\Microsoft\\Internet Explorer\\Main\\FeatureControl\\FEATURE_GPU_RENDERING\\mshta.exe')
    }
    catch (err) {}

    if (HTA_use_GPU_acceleration <= 1)
      break
    HTA_use_GPU_acceleration = false
  }

  HTA_use_GPU_acceleration = !!HTA_use_GPU_acceleration
  return HTA_use_GPU_acceleration
}


// For debug START
var DEBUG_count = 0
var DEBUG_timerID
var DEBUG_always_visible
var DEBUG_hide_sec = 0
var DEBUG_last_display_time = 0

function DEBUG_show(msg, hide_sec, always_visible) {
  if (always_visible)
    DEBUG_always_visible = true
//DEBUG_always_visible = true
  if (DEBUG_timerID || DEBUG_always_visible)
    msg = Ldebug.innerText + " | " + msg

  var time
  if (hide_sec)
    time = Date.now()

  if (DEBUG_timerID) {
    clearTimeout(DEBUG_timerID)
    DEBUG_timerID = null

    if (hide_sec && (msg || (msg == 0))) {
      if (DEBUG_last_display_time) {
        var time_diff = parseInt(DEBUG_hide_sec - 1 - (time - DEBUG_last_display_time) / 1000)
        if (time_diff > 0)
          hide_sec += time_diff
      }
      if (hide_sec > 30)
        hide_sec = 30
    }
  }

  if (msg || (msg == 0)) {
    Ldebug.innerText = msg

    if (!self.use_Silverlight || !self.SL_DEBUG_show || self.SL_windowless || !self.SL_loaded)
      Ldebug.style.visibility = "inherit"

    if (hide_sec && !DEBUG_always_visible) {
      DEBUG_hide_sec = hide_sec
      DEBUG_last_display_time = time
      DEBUG_timerID = setTimeout('DEBUG_timerID=null; DEBUG_hide_sec=DEBUG_last_display_time=0; DEBUG_show()', hide_sec*1000)
    }
  }
  else
    Ldebug.style.visibility = "hidden"

// Silverlight START
  if (self.SL_DEBUG_show)
    SL_DEBUG_show(msg)
}
// For debug END
