// SVG Clock (v1.1.1)

var SVG_Clock_scale, SVG_Clock_x_center, SVG_Clock_y_center, SVG_Clock_opacity_mod

var SVG_Clock = {
  second_last: -1
 ,minute_last: -1
 ,hour_last: -1

 ,scale: 1
 ,x_center: 0
 ,y_center: 0
 ,opacity_mod: 1

 ,dim_last: -1

 ,draw: function () {
if (SVG_Clock_scale)
  this.scale = SVG_Clock_scale
if (SVG_Clock_x_center)
  this.x_center = SVG_Clock_x_center
if (SVG_Clock_y_center)
  this.y_center = SVG_Clock_y_center
if (SVG_Clock_opacity_mod)
  this.opacity_mod = SVG_Clock_opacity_mod

var opacity_mod = this.opacity_mod

var d = document.createElement("div")
d.id = "Vclock_host"
var ds = d.style
ds.position = "absolute"
ds.posLeft = ds.posTop = 0
ds.zIndex = 99
Lbody.appendChild(d)

var html
html =
  '<svg id="Vclock_parent" xmlns="http://www.w3.org/2000/svg" version="1.1" style="position:absolute; top:0px; left:0px">\n'
+ '<g id="Vclock">\n'

for (var i = 0; i < 4; i++) {
  html += '<rect x="58" y="1" width="4" height="10" transform="rotate(' + (i*90) + ', 60,60)" style="fill:rgba(255,255,255,' + (0.5 * opacity_mod) + '); stroke:rgba(85,85,85,' + (0.75 * opacity_mod) + '); stroke-width:0.5"/>\n'
  for (var k = 0; k < 2; k++)
    html += '<polygon points="58,1 62,1 60,6" transform="rotate(' + (i*90+(k+1)*30) + ', 60,60)" style="fill:rgba(255,255,255,' + (0.5 * opacity_mod) + '); stroke:rgba(85,85,85,' + (0.75 * opacity_mod) + '); stroke-width:0.5"/>\n'
}

html +=
  '<polygon id="Vclock_s" points="60,2  58,64 62,64" style="fill:rgba(255,128,128,' + (0.5 * opacity_mod) + '); stroke:rgba(0,0,0,' + (0.75 * opacity_mod) + '); stroke-width:0.5"/>\n'
+ '<polygon id="Vclock_m" points="60,8  56,66 64,66" style="fill:rgba(128,255,128,' + (0.5 * opacity_mod) + '); stroke:rgba(0,0,0,' + (0.75 * opacity_mod) + '); stroke-width:0.5"/>\n'
+ '<polygon id="Vclock_h" points="60,20 54,68 66,68" style="fill:rgba(128,128,255,' + (0.5 * opacity_mod) + '); stroke:rgba(0,0,0,' + (0.75 * opacity_mod) + '); stroke-width:0.5"/>\n'

+ '<circle cx="60" cy="60" r="2" style="fill:rgba(255,255,255,' + (0.5 * opacity_mod) + '); stroke:rgba(0,0,0,' + (0.75 * opacity_mod) + '); stroke-width:0.5"/>\n'

+ '</g>\n'
+ '</svg> '

d.innerHTML = html
  }

 ,rotate: function (p, v) {
p.setAttribute("transform", "rotate(" + v + ", 60,60)");
  }

 ,resize: function (w,h) {
var dim = (w < h) ? w : h
dim *= this.scale

if (this.dim_last == dim)
  return
this.dim_last = dim

var cs = Vclock_host.style
cs.posLeft = parseInt((w - dim) * 0.5 * (1+this.x_center))
cs.posTop  = parseInt((h - dim) * 0.5 * (1+this.y_center))

var vs = Vclock_parent.style
vs.pixelWidth = vs.pixelHeight = dim

Vclock.setAttribute("transform", "scale(" + (dim/120) + ")");

this.update()
  }

 ,update: function () {
var now = new Date();

var hour = now.getHours();
if (this.hour_last != hour)
  this.hour_last = hour

var minute = now.getMinutes();
if (this.minute_last != minute) {
  this.minute_last = minute
  this.rotate(Vclock_m, minute * 6)
  this.rotate(Vclock_h, hour * 30 + minute / 2)
}

var second = now.getSeconds();
if (this.second_last != second) {
  this.second_last = second
  this.rotate(Vclock_s, second * 6)
}
  }
}
