// WMI JS library (v2.2.0)
// NOTE: "SWbemRefresher" can be used ONLY on "Win32_Perf" data. Using it on other objects causes MEMORY LEAK.

var WMI_obj
var WMI_objs_count = 0
var WMI_refreshers = []
var WMI_refreshers_count = 0

var PC_count_absolute = 0

var xul_mode, webkit_mode

var WMI_AL_mode//=true
if (xul_mode || webkit_mode) WMI_AL_mode=true
var WMI_AL_timerID
var WMI_AL_js_path, WMI_AL_temp_path, WMI_AL_temp_filename
var WMI_AL_WSH_result_obj
var WMI_AL_refresher_id = []

var Shell_OBJ, FSO_OBJ, oShell

function WMI_CreateObject(always_create_WMI) {
  if (WMI_AL_mode) {
    if (!Shell_OBJ)
      Shell_OBJ = new ActiveXObject("Shell.Application");
    if (!FSO_OBJ)
      FSO_OBJ = new ActiveXObject("Scripting.FileSystemObject");
    if (!oShell)
      oShell = new ActiveXObject("WScript.Shell");

    if (!always_create_WMI || xul_mode || webkit_mode)
      return
  }

  if (WMI_obj)
    return

  WMI_obj = (self.GetObject) ? GetObject("winmgmts:") : new ActiveXObject("WbemScripting.SWbemLocator").ConnectServer();
}

function WMI_Refresher(WMI_class, refresher_id) {
  this.loaded = false
  this.refresher = null
  this.objs = null
  this.collection = []

  this.WMI_class = WMI_class
  this.refresher_id = (refresher_id) ? refresher_id : null

  this.init = WMI_Refresher_init
  this.update = WMI_Refresher_update
  this.refresh = WMI_Refresher_refresh
}

function WMI_Refresher_init() {
  if (this.loaded)
    return
  this.loaded = true

  if (this.refresher_id)
    WMI_objs_count++

try {
  WMI_CreateObject(!this.refresher_id)

  if (WMI_AL_mode) {
    if (!this.refresher_id)
      return

    WMI_AL_refresher_id[this.WMI_class] = this.refresher_id
    WMI_AL_run_timer()
    return
  }

  if (!this.refresher_id)
    return

  var r = WMI_refreshers[this.refresher_id]
  if (!r) {
    r = { obj:new ActiveXObject("WbemScripting.SWbemRefresher"), WMI_class_objs:{} }
    WMI_refreshers[this.refresher_id] = r
    WMI_refreshers_count++
  }
  this.refresher = r

  var r_objs = r.WMI_class_objs[this.WMI_class]
  if (r_objs)
    this.objs = r_objs
  else
    this.objs = r.WMI_class_objs[this.WMI_class] = r.obj.AddEnum(WMI_obj, this.WMI_class)
}
catch (err) {alert(err.toString())}

}

function WMI_Refresher_refresh() {

try {
  if (!this.refresher_id)
    return
  if (WMI_AL_mode)
    return

  var r = this.refresher
  if (r.refreshed_count_last == PC_count_absolute)
    return true

  r.refreshed_count_last = PC_count_absolute
  r.obj.Refresh()
}
catch (ex) {}

}

function WMI_Refresher_update(query_str) {
  var objs = []
try {
  if (this.refresh() && (this.refreshed_count_last == PC_count_absolute))
    objs = this.collection
  else {
    if (WMI_AL_mode && this.refresher_id) {
      var filename = WMI_AL_temp_path+'\\'+WMI_AL_temp_filename + '.txt'

      var WSH_result_obj
      if (WMI_AL_WSH_result_obj && (this.refreshed_count_last == PC_count_absolute))
        WSH_result_obj = WMI_AL_WSH_result_obj
      else {
        try {
          if (FSO_OBJ.FileExists(filename)) {
            var f = FSO_OBJ.OpenTextFile(filename, 1)

var txt = f.ReadLine()
if (document.documentMode >= 8)
  WMI_AL_WSH_result_obj = WSH_result_obj = JSON.parse(txt)
else
  eval('WMI_AL_WSH_result_obj = WSH_result_obj = ' + txt)

            f.Close()
          }
        }
        catch (err) { WMI_AL_WSH_result_obj = WSH_result_obj = null }
      }

      var c = this.WMI_class

      if (!WSH_result_obj || !WSH_result_obj[c]) {
        var c_ref = WMI_AL_ref[c]

        for (var i = 0; i < c_ref.collection_length_default; i++)
          objs.push(c_ref.properties)
      }
      else
        objs = WSH_result_obj[c]
    }
    else {
      var need_enum = true
      var en_objs
      if (this.refresher_id)
        en_objs = this.objs.ObjectSet
      else {
        if (xul_mode || webkit_mode) {

// XUL one-time special
need_enum = false

var c = this.WMI_class
var para = c + ",(),0"

var js_path = System.Gadget.path + '\\js\\wmi_al.wsf';
var temp_path = oShell.ExpandEnvironmentStrings("%TEMP%"); //js_path.replace(/\\[^\\]+$/, '\\TEMP');
var temp_filename = "TEMP_WMI_one-time" + ("_" + new Date().getTime()) + ("-" + Math.random()).replace(/0\./, "");

var txt, WSH_result_obj

if (xul_mode) {
  XPCOM_object["Shell.Application"]._run(js_path, encodeURIComponent(temp_filename) + " " + encodeURIComponent(para), true, SystemEXT.enforce_WSH);
  try {
    var temp_file = FileIO.open(temp_path + '\\' + temp_filename + '.txt');
    txt = FileIO.readText(temp_file);
    FileIO.unlink(temp_file);
  }
  catch (err) { DEBUG_show(err.toString()) }
}
else {
  WebKit_object["Shell.Application"]._run(js_path, encodeURIComponent(temp_filename) + " " + encodeURIComponent(para), null, true);
  temp_path += '\\' + temp_filename + '.txt';
  try {
    var fs = require('fs')
    if (fs.existsSync(temp_path)) {
      txt = fs.readFileSync(temp_path)
      fs.unlinkSync(temp_path)
    }
  }
  catch (err) { DEBUG_show(err.toString()) }
}

if (txt)
  WSH_result_obj = JSON.parse(txt)

if (!WSH_result_obj || !WSH_result_obj[c]) {
  var c_ref = WMI_AL_ref[c]

  for (var i = 0; i < c_ref.collection_length_default; i++)
    objs.push(c_ref.properties)
}
else
  objs = WSH_result_obj[c]

        }
        else if (!query_str) {
          en_objs = WMI_obj.InstancesOf(this.WMI_class)
        }
        else {
          en_objs = WMI_obj.ExecQuery('SELECT * FROM ' + this.WMI_class + ' WHERE ' + query_str)
        }
      }

      if (need_enum) {
        var en = new Enumerator(en_objs)
        for (; !en.atEnd(); en.moveNext())
          objs.push(en.item())
      }
    }

    this.refreshed_count_last = PC_count_absolute
  }
}
catch (ex) {}

  this.collection = objs
  return objs
}


// WMI Anit-leak functions

function WMI_AL_stop() {
  try {
    if (WMI_AL_mode && WMI_objs_count) {
      FSO_OBJ.DeleteFile(WMI_AL_temp_path+'\\'+WMI_AL_temp_filename + '.tmp')
    }
  }
  catch (err) {alert(err.toString())}
}

var WMI_AL_script_running

function WMI_AL_run_timer() {
  if (WMI_AL_script_running)
    return

  if (WMI_AL_timerID) {
    clearTimeout(WMI_AL_timerID)
    WMI_AL_timerID = null
  }

  WMI_AL_timerID = setTimeout(WMI_AL_run_command, 10)
}

function WMI_AL_run_command() {
  var paras = []
  var c
  for (c in WMI_AL_refresher_id) {
    if (c && !/shuffle/.test(c)) {
      paras.push(c + "," + WMI_AL_refresher_id[c] + "," + eval(WMI_AL_ref[c].timer_interval))
    }
  }

  if (!paras.length)
    return

  if (!WMI_AL_js_path)
    WMI_AL_js_path = System.Gadget.path + '\\js\\wmi_al.wsf'
  if (!WMI_AL_temp_path)
    WMI_AL_temp_path = oShell.ExpandEnvironmentStrings("%TEMP%"); //WMI_AL_js_path.replace(/\\[^\\]+$/, '\\TEMP')
  if (!WMI_AL_temp_filename)
    WMI_AL_temp_filename = ((self.Settings && Settings.f_path) ? Settings.f_path.replace(/^.+\\/, '').replace(/\s/g, "_") : "TEMP") + ("_" + new Date().getTime()) + ("-" + Math.random()).replace(/0\./, "")

  FSO_OBJ.OpenTextFile(WMI_AL_temp_path+'\\'+WMI_AL_temp_filename + '.txt', 2, true).Close()
  FSO_OBJ.OpenTextFile(WMI_AL_temp_path+'\\'+WMI_AL_temp_filename + '.tmp', 2, true).Close()

  WMI_AL_script_running = true
  Shell_OBJ.ShellExecute(WMI_AL_js_path, encodeURIComponent(WMI_AL_temp_filename) + " " + encodeURIComponent(paras.join("|")))
}


// scripts
if (WMI_AL_mode)
  document.write('<script type="text/javascript" language="javascript" src="js/wmi_al_core.js"></scr'+'ipt>\n')
